diff --git a/app/test-bbdev/meson.build b/app/test-bbdev/meson.build
index 6d50e03396..57335641f0 100644
--- a/app/test-bbdev/meson.build
+++ b/app/test-bbdev/meson.build
@@ -1,17 +1,19 @@
 # SPDX-License-Identifier: BSD-3-Clause
 # Copyright(c) 2018 Intel Corporation
 
-sources = files('main.c',
-		'test_bbdev.c',
-		'test_bbdev_perf.c',
-		'test_bbdev_vector.c')
+sources = files(
+        'main.c',
+        'test_bbdev.c',
+        'test_bbdev_perf.c',
+        'test_bbdev_vector.c',
+)
 deps += ['bbdev', 'bus_vdev']
 if dpdk_conf.has('RTE_BASEBAND_FPGA_LTE_FEC')
-	deps += ['baseband_fpga_lte_fec']
+    deps += ['baseband_fpga_lte_fec']
 endif
 if dpdk_conf.has('RTE_BASEBAND_FPGA_5GNR_FEC')
-	deps += ['baseband_fpga_5gnr_fec']
+    deps += ['baseband_fpga_5gnr_fec']
 endif
 if dpdk_conf.has('RTE_BASEBAND_ACC100')
-	deps += ['baseband_acc100']
+    deps += ['baseband_acc100']
 endif
diff --git a/app/test-compress-perf/meson.build b/app/test-compress-perf/meson.build
index a1a484da9a..3f79e2da9d 100644
--- a/app/test-compress-perf/meson.build
+++ b/app/test-compress-perf/meson.build
@@ -1,10 +1,12 @@
 # SPDX-License-Identifier: BSD-3-Clause
 # Copyright(c) 2018 Intel Corporation
 
-sources = files('comp_perf_options_parse.c',
-		'main.c',
-		'comp_perf_test_verify.c',
-		'comp_perf_test_throughput.c',
-		'comp_perf_test_cyclecount.c',
-		'comp_perf_test_common.c')
+sources = files(
+        'comp_perf_options_parse.c',
+        'comp_perf_test_common.c',
+        'comp_perf_test_cyclecount.c',
+        'comp_perf_test_throughput.c',
+        'comp_perf_test_verify.c',
+        'main.c',
+)
 deps = ['compressdev']
diff --git a/app/test-crypto-perf/meson.build b/app/test-crypto-perf/meson.build
index 558c648788..20444b7912 100644
--- a/app/test-crypto-perf/meson.build
+++ b/app/test-crypto-perf/meson.build
@@ -1,17 +1,19 @@
 # SPDX-License-Identifier: BSD-3-Clause
 # Copyright(c) 2018 Intel Corporation
 
-sources = files('cperf_ops.c',
-		'cperf_options_parsing.c',
-		'cperf_test_common.c',
-		'cperf_test_latency.c',
-		'cperf_test_pmd_cyclecount.c',
-		'cperf_test_throughput.c',
-		'cperf_test_vector_parsing.c',
-		'cperf_test_vectors.c',
-		'cperf_test_verify.c',
-		'main.c')
+sources = files(
+        'cperf_ops.c',
+        'cperf_options_parsing.c',
+        'cperf_test_common.c',
+        'cperf_test_latency.c',
+        'cperf_test_pmd_cyclecount.c',
+        'cperf_test_throughput.c',
+        'cperf_test_vector_parsing.c',
+        'cperf_test_vectors.c',
+        'cperf_test_verify.c',
+        'main.c',
+)
 deps += ['cryptodev', 'net', 'security']
 if dpdk_conf.has('RTE_CRYPTO_SCHEDULER')
-	deps += 'crypto_scheduler'
+    deps += 'crypto_scheduler'
 endif
diff --git a/app/test-eventdev/meson.build b/app/test-eventdev/meson.build
index 9e588d9ec7..04117dbe4f 100644
--- a/app/test-eventdev/meson.build
+++ b/app/test-eventdev/meson.build
@@ -1,17 +1,19 @@
 # SPDX-License-Identifier: BSD-3-Clause
 # Copyright(c) 2017 Cavium, Inc
 
-sources = files('evt_main.c',
-		'evt_options.c',
-		'evt_test.c',
-		'parser.c',
-		'test_order_common.c',
-		'test_order_atq.c',
-		'test_order_queue.c',
-		'test_perf_common.c',
-		'test_perf_atq.c',
-		'test_perf_queue.c',
-		'test_pipeline_common.c',
-		'test_pipeline_atq.c',
-		'test_pipeline_queue.c')
+sources = files(
+        'evt_main.c',
+        'evt_options.c',
+        'evt_test.c',
+        'parser.c',
+        'test_order_atq.c',
+        'test_order_common.c',
+        'test_order_queue.c',
+        'test_perf_atq.c',
+        'test_perf_common.c',
+        'test_perf_queue.c',
+        'test_pipeline_atq.c',
+        'test_pipeline_common.c',
+        'test_pipeline_queue.c'
+)
 deps += 'eventdev'
diff --git a/app/test-flow-perf/meson.build b/app/test-flow-perf/meson.build
index 6eaf83b41a..1d860e036a 100644
--- a/app/test-flow-perf/meson.build
+++ b/app/test-flow-perf/meson.build
@@ -2,10 +2,10 @@
 # Copyright(c) 2020 Mellanox Technologies, Ltd
 
 sources = files(
-	'actions_gen.c',
-	'flow_gen.c',
-	'items_gen.c',
-	'main.c',
+        'actions_gen.c',
+        'flow_gen.c',
+        'items_gen.c',
+        'main.c',
 )
 
 deps += ['ethdev']
diff --git a/app/test-pipeline/meson.build b/app/test-pipeline/meson.build
index d5eddaba99..fd91f83231 100644
--- a/app/test-pipeline/meson.build
+++ b/app/test-pipeline/meson.build
@@ -2,13 +2,14 @@
 # Copyright(c) 2019 Intel Corporation
 
 sources = files(
-	'config.c',
-	'init.c',
-	'main.c',
-	'pipeline_acl.c',
-	'pipeline_hash.c',
-	'pipeline_lpm.c',
-	'pipeline_lpm_ipv6.c',
-	'pipeline_stub.c',
-	'runtime.c')
+        'config.c',
+        'init.c',
+        'main.c',
+        'pipeline_acl.c',
+        'pipeline_hash.c',
+        'pipeline_lpm.c',
+        'pipeline_lpm_ipv6.c',
+        'pipeline_stub.c',
+        'runtime.c',
+)
 deps += ['pipeline', 'pci']
diff --git a/app/test-pmd/meson.build b/app/test-pmd/meson.build
index 7e9c7bdd69..98f3289bdf 100644
--- a/app/test-pmd/meson.build
+++ b/app/test-pmd/meson.build
@@ -4,58 +4,60 @@
 # override default name to drop the hyphen
 name = 'testpmd'
 cflags += '-Wno-deprecated-declarations'
-sources = files('5tswap.c',
-	'cmdline.c',
-	'cmdline_flow.c',
-	'cmdline_mtr.c',
-	'cmdline_tm.c',
-	'config.c',
-	'csumonly.c',
-	'flowgen.c',
-	'icmpecho.c',
-	'ieee1588fwd.c',
-	'iofwd.c',
-	'macfwd.c',
-	'macswap.c',
-	'noisy_vnf.c',
-	'parameters.c',
-	'rxonly.c',
-	'testpmd.c',
-	'txonly.c',
-	'util.c')
+sources = files(
+        '5tswap.c',
+        'cmdline.c',
+        'cmdline_flow.c',
+        'cmdline_mtr.c',
+        'cmdline_tm.c',
+        'config.c',
+        'csumonly.c',
+        'flowgen.c',
+        'icmpecho.c',
+        'ieee1588fwd.c',
+        'iofwd.c',
+        'macfwd.c',
+        'macswap.c',
+        'noisy_vnf.c',
+        'parameters.c',
+        'rxonly.c',
+        'testpmd.c',
+        'txonly.c',
+        'util.c',
+)
 
 deps += ['ethdev', 'gro', 'gso', 'cmdline', 'metrics', 'meter', 'bus_pci']
 if dpdk_conf.has('RTE_LIB_BITRATESTATS')
-	deps += 'bitratestats'
+    deps += 'bitratestats'
 endif
 if dpdk_conf.has('RTE_LIB_PDUMP')
-	deps += 'pdump'
+    deps += 'pdump'
 endif
 if dpdk_conf.has('RTE_LIB_BITRATESTATS')
-	deps += 'bitratestats'
+    deps += 'bitratestats'
 endif
 if dpdk_conf.has('RTE_LIB_LATENCYSTATS')
-	deps += 'latencystats'
+    deps += 'latencystats'
 endif
 if dpdk_conf.has('RTE_CRYPTO_SCHEDULER')
-	deps += 'crypto_scheduler'
+    deps += 'crypto_scheduler'
 endif
 if dpdk_conf.has('RTE_NET_BOND')
-	deps += 'net_bond'
+    deps += 'net_bond'
 endif
 if dpdk_conf.has('RTE_NET_BNXT')
-	deps += 'net_bnxt'
+    deps += 'net_bnxt'
 endif
 if dpdk_conf.has('RTE_NET_I40E')
-	deps += 'net_i40e'
+    deps += 'net_i40e'
 endif
 if dpdk_conf.has('RTE_NET_IXGBE')
-	deps += 'net_ixgbe'
+    deps += 'net_ixgbe'
 endif
 if dpdk_conf.has('RTE_NET_DPAA')
-	deps += ['bus_dpaa', 'mempool_dpaa', 'net_dpaa']
+    deps += ['bus_dpaa', 'mempool_dpaa', 'net_dpaa']
 endif
 if dpdk_conf.has('RTE_LIB_BPF')
-	sources += files('bpf_cmd.c')
-	deps += 'bpf'
+    sources += files('bpf_cmd.c')
+    deps += 'bpf'
 endif
diff --git a/app/test/meson.build b/app/test/meson.build
index bd50818f82..08c82d3d23 100644
--- a/app/test/meson.build
+++ b/app/test/meson.build
@@ -2,181 +2,183 @@
 # Copyright(c) 2017 Intel Corporation
 
 if not get_option('tests')
-	subdir_done()
+    subdir_done()
 endif
 
-test_sources = files('commands.c',
-	'packet_burst_generator.c',
-	'test.c',
-	'test_acl.c',
-	'test_alarm.c',
-	'test_atomic.c',
-	'test_barrier.c',
-	'test_bitops.c',
-	'test_bitmap.c',
-	'test_bpf.c',
-	'test_byteorder.c',
-	'test_cmdline.c',
-	'test_cmdline_cirbuf.c',
-	'test_cmdline_etheraddr.c',
-	'test_cmdline_ipaddr.c',
-	'test_cmdline_lib.c',
-	'test_cmdline_num.c',
-	'test_cmdline_portlist.c',
-	'test_cmdline_string.c',
-	'test_common.c',
-	'test_cpuflags.c',
-	'test_crc.c',
-	'test_cryptodev.c',
-	'test_cryptodev_asym.c',
-	'test_cryptodev_blockcipher.c',
-	'test_cryptodev_security_pdcp.c',
-	'test_cycles.c',
-	'test_debug.c',
-	'test_distributor.c',
-	'test_distributor_perf.c',
-	'test_eal_flags.c',
-	'test_eal_fs.c',
-	'test_efd.c',
-	'test_efd_perf.c',
-	'test_errno.c',
-	'test_ethdev_link.c',
-	'test_event_crypto_adapter.c',
-	'test_event_eth_rx_adapter.c',
-	'test_event_ring.c',
-	'test_event_timer_adapter.c',
-	'test_eventdev.c',
-	'test_external_mem.c',
-	'test_fbarray.c',
-	'test_fib.c',
-	'test_fib_perf.c',
-	'test_fib6.c',
-	'test_fib6_perf.c',
-	'test_func_reentrancy.c',
-	'test_flow_classify.c',
-	'test_graph.c',
-	'test_graph_perf.c',
-	'test_hash.c',
-	'test_hash_functions.c',
-	'test_hash_multiwriter.c',
-	'test_hash_readwrite.c',
-	'test_hash_perf.c',
-	'test_hash_readwrite_lf_perf.c',
-	'test_interrupts.c',
+test_sources = files(
+        'commands.c',
+        'packet_burst_generator.c',
+        'test.c',
+        'test_acl.c',
+        'test_alarm.c',
+        'test_atomic.c',
+        'test_barrier.c',
+        'test_bitops.c',
+        'test_bitmap.c',
+        'test_bpf.c',
+        'test_byteorder.c',
+        'test_cmdline.c',
+        'test_cmdline_cirbuf.c',
+        'test_cmdline_etheraddr.c',
+        'test_cmdline_ipaddr.c',
+        'test_cmdline_lib.c',
+        'test_cmdline_num.c',
+        'test_cmdline_portlist.c',
+        'test_cmdline_string.c',
+        'test_common.c',
+        'test_cpuflags.c',
+        'test_crc.c',
+        'test_cryptodev.c',
+        'test_cryptodev_asym.c',
+        'test_cryptodev_blockcipher.c',
+        'test_cryptodev_security_pdcp.c',
+        'test_cycles.c',
+        'test_debug.c',
+        'test_distributor.c',
+        'test_distributor_perf.c',
+        'test_eal_flags.c',
+        'test_eal_fs.c',
+        'test_efd.c',
+        'test_efd_perf.c',
+        'test_errno.c',
+        'test_ethdev_link.c',
+        'test_event_crypto_adapter.c',
+        'test_event_eth_rx_adapter.c',
+        'test_event_ring.c',
+        'test_event_timer_adapter.c',
+        'test_eventdev.c',
+        'test_external_mem.c',
+        'test_fbarray.c',
+        'test_fib.c',
+        'test_fib_perf.c',
+        'test_fib6.c',
+        'test_fib6_perf.c',
+        'test_func_reentrancy.c',
+        'test_flow_classify.c',
+        'test_graph.c',
+        'test_graph_perf.c',
+        'test_hash.c',
+        'test_hash_functions.c',
+        'test_hash_multiwriter.c',
+        'test_hash_readwrite.c',
+        'test_hash_perf.c',
+        'test_hash_readwrite_lf_perf.c',
+        'test_interrupts.c',
         'test_ipfrag.c',
-	'test_ipsec.c',
-	'test_ipsec_sad.c',
-	'test_ipsec_perf.c',
-	'test_kni.c',
-	'test_kvargs.c',
-	'test_lcores.c',
-	'test_logs.c',
-	'test_lpm.c',
-	'test_lpm6.c',
-	'test_lpm6_perf.c',
-	'test_lpm_perf.c',
-	'test_malloc.c',
-	'test_mbuf.c',
-	'test_member.c',
-	'test_member_perf.c',
-	'test_memcpy.c',
-	'test_memcpy_perf.c',
-	'test_memory.c',
-	'test_mempool.c',
-	'test_mempool_perf.c',
-	'test_memzone.c',
-	'test_meter.c',
-	'test_metrics.c',
-	'test_mcslock.c',
-	'test_mp_secondary.c',
-	'test_per_lcore.c',
-	'test_pflock.c',
-	'test_pmd_perf.c',
-	'test_power.c',
-	'test_power_cpufreq.c',
-	'test_power_kvm_vm.c',
-	'test_prefetch.c',
-	'test_rand_perf.c',
-	'test_rawdev.c',
-	'test_rcu_qsbr.c',
-	'test_rcu_qsbr_perf.c',
-	'test_reciprocal_division.c',
-	'test_reciprocal_division_perf.c',
-	'test_red.c',
-	'test_reorder.c',
-	'test_rib.c',
-	'test_rib6.c',
-	'test_ring.c',
-	'test_ring_mpmc_stress.c',
-	'test_ring_hts_stress.c',
-	'test_ring_mt_peek_stress.c',
-	'test_ring_mt_peek_stress_zc.c',
-	'test_ring_perf.c',
-	'test_ring_rts_stress.c',
-	'test_ring_st_peek_stress.c',
-	'test_ring_st_peek_stress_zc.c',
-	'test_ring_stress.c',
-	'test_rwlock.c',
-	'test_sched.c',
-	'test_security.c',
-	'test_service_cores.c',
-	'test_spinlock.c',
-	'test_stack.c',
-	'test_stack_perf.c',
-	'test_string_fns.c',
-	'test_table.c',
-	'test_table_acl.c',
-	'test_table_combined.c',
-	'test_table_pipeline.c',
-	'test_table_ports.c',
-	'test_table_tables.c',
-	'test_tailq.c',
-	'test_thash.c',
-	'test_timer.c',
-	'test_timer_perf.c',
-	'test_timer_racecond.c',
-	'test_timer_secondary.c',
-	'test_ticketlock.c',
-	'test_trace.c',
-	'test_trace_register.c',
-	'test_trace_perf.c',
-	'test_version.c',
-	'virtual_pmd.c'
+        'test_ipsec.c',
+        'test_ipsec_sad.c',
+        'test_ipsec_perf.c',
+        'test_kni.c',
+        'test_kvargs.c',
+        'test_lcores.c',
+        'test_logs.c',
+        'test_lpm.c',
+        'test_lpm6.c',
+        'test_lpm6_perf.c',
+        'test_lpm_perf.c',
+        'test_malloc.c',
+        'test_mbuf.c',
+        'test_member.c',
+        'test_member_perf.c',
+        'test_memcpy.c',
+        'test_memcpy_perf.c',
+        'test_memory.c',
+        'test_mempool.c',
+        'test_mempool_perf.c',
+        'test_memzone.c',
+        'test_meter.c',
+        'test_metrics.c',
+        'test_mcslock.c',
+        'test_mp_secondary.c',
+        'test_per_lcore.c',
+        'test_pflock.c',
+        'test_pmd_perf.c',
+        'test_power.c',
+        'test_power_cpufreq.c',
+        'test_power_kvm_vm.c',
+        'test_prefetch.c',
+        'test_rand_perf.c',
+        'test_rawdev.c',
+        'test_rcu_qsbr.c',
+        'test_rcu_qsbr_perf.c',
+        'test_reciprocal_division.c',
+        'test_reciprocal_division_perf.c',
+        'test_red.c',
+        'test_reorder.c',
+        'test_rib.c',
+        'test_rib6.c',
+        'test_ring.c',
+        'test_ring_mpmc_stress.c',
+        'test_ring_hts_stress.c',
+        'test_ring_mt_peek_stress.c',
+        'test_ring_mt_peek_stress_zc.c',
+        'test_ring_perf.c',
+        'test_ring_rts_stress.c',
+        'test_ring_st_peek_stress.c',
+        'test_ring_st_peek_stress_zc.c',
+        'test_ring_stress.c',
+        'test_rwlock.c',
+        'test_sched.c',
+        'test_security.c',
+        'test_service_cores.c',
+        'test_spinlock.c',
+        'test_stack.c',
+        'test_stack_perf.c',
+        'test_string_fns.c',
+        'test_table.c',
+        'test_table_acl.c',
+        'test_table_combined.c',
+        'test_table_pipeline.c',
+        'test_table_ports.c',
+        'test_table_tables.c',
+        'test_tailq.c',
+        'test_thash.c',
+        'test_timer.c',
+        'test_timer_perf.c',
+        'test_timer_racecond.c',
+        'test_timer_secondary.c',
+        'test_ticketlock.c',
+        'test_trace.c',
+        'test_trace_register.c',
+        'test_trace_perf.c',
+        'test_version.c',
+        'virtual_pmd.c',
 )
 
-test_deps = ['acl',
-	'bus_pci',
-	'bus_vdev',
-	'bitratestats',
-	'bpf',
-	'cfgfile',
-	'cmdline',
-	'cryptodev',
-	'distributor',
-	'efd',
-	'ethdev',
-	'eventdev',
-	'fib',
-	'flow_classify',
-	'graph',
-	'hash',
-	'ipsec',
-	'latencystats',
-	'lpm',
-	'member',
-	'metrics',
-	'node',
-	'pipeline',
-	'port',
-	'rawdev',
-	'rcu',
-	'reorder',
-	'rib',
-	'ring',
-	'security',
-	'stack',
-	'telemetry',
-	'timer'
+test_deps = [
+        'acl',
+        'bus_pci',
+        'bus_vdev',
+        'bitratestats',
+        'bpf',
+        'cfgfile',
+        'cmdline',
+        'cryptodev',
+        'distributor',
+        'efd',
+        'ethdev',
+        'eventdev',
+        'fib',
+        'flow_classify',
+        'graph',
+        'hash',
+        'ipsec',
+        'latencystats',
+        'lpm',
+        'member',
+        'metrics',
+        'node',
+        'pipeline',
+        'port',
+        'rawdev',
+        'rcu',
+        'reorder',
+        'rib',
+        'ring',
+        'security',
+        'stack',
+        'telemetry',
+        'timer',
 ]
 
 # Each test is marked with flag true/false
@@ -241,7 +243,7 @@ fast_tests = [
         ['rwlock_rds_wrm_autotest', true],
         ['rwlock_rde_wro_autotest', true],
         ['sched_autotest', true],
-		['security_autotest', false],
+        ['security_autotest', false],
         ['spinlock_autotest', true],
         ['stack_autotest', false],
         ['stack_lf_autotest', false],
@@ -306,7 +308,7 @@ perf_test_names = [
         'hash_readwrite_perf_autotest',
         'hash_readwrite_lf_perf_autotest',
         'trace_perf_autotest',
-	'ipsec_perf_autotest',
+        'ipsec_perf_autotest',
 ]
 
 driver_test_names = [
@@ -345,55 +347,55 @@ dump_test_names = [
 # DPDK libraries.  Explicit linkage of drivers (plugin libraries)
 # in applications should not be used.
 if dpdk_conf.has('RTE_MEMPOOL_RING')
-	test_deps += 'mempool_ring'
+    test_deps += 'mempool_ring'
 endif
 if dpdk_conf.has('RTE_MEMPOOL_STACK')
-	test_deps += 'mempool_stack'
+    test_deps += 'mempool_stack'
 endif
 if dpdk_conf.has('RTE_EVENT_SKELETON')
-	test_deps += 'event_skeleton'
+    test_deps += 'event_skeleton'
 endif
 if dpdk_conf.has('RTE_LIB_TELEMETRY')
-	test_sources += ['test_telemetry_json.c', 'test_telemetry_data.c']
-	fast_tests += [['telemetry_json_autotest', true], ['telemetry_data_autotest', true]]
+    test_sources += ['test_telemetry_json.c', 'test_telemetry_data.c']
+    fast_tests += [['telemetry_json_autotest', true], ['telemetry_data_autotest', true]]
 endif
 
 # The following linkages of drivers are required because
 # they are used via a driver-specific API.
 if dpdk_conf.has('RTE_NET_BOND')
-	test_deps += 'net_bond'
-	test_sources += ['test_link_bonding.c', 'test_link_bonding_rssconf.c']
-	driver_test_names += ['link_bonding_autotest', 'link_bonding_rssconf_autotest']
-	if dpdk_conf.has('RTE_NET_RING')
-		test_sources += 'test_link_bonding_mode4.c'
-		driver_test_names += 'link_bonding_mode4_autotest'
-	endif
+    test_deps += 'net_bond'
+    test_sources += ['test_link_bonding.c', 'test_link_bonding_rssconf.c']
+    driver_test_names += ['link_bonding_autotest', 'link_bonding_rssconf_autotest']
+    if dpdk_conf.has('RTE_NET_RING')
+        test_sources += 'test_link_bonding_mode4.c'
+        driver_test_names += 'link_bonding_mode4_autotest'
+    endif
 endif
 if dpdk_conf.has('RTE_NET_RING')
-	test_deps += 'net_ring'
-	test_sources += 'test_pmd_ring_perf.c'
-	test_sources += 'test_pmd_ring.c'
-	test_sources += 'test_event_eth_tx_adapter.c'
-	test_sources += 'test_bitratestats.c'
-	test_sources += 'test_latencystats.c'
-	test_sources += 'sample_packet_forward.c'
-	test_sources += 'test_pdump.c'
-	fast_tests += [['ring_pmd_autotest', true]]
-	perf_test_names += 'ring_pmd_perf_autotest'
-	fast_tests += [['event_eth_tx_adapter_autotest', false]]
-	fast_tests += [['bitratestats_autotest', true]]
-	fast_tests += [['latencystats_autotest', true]]
-	fast_tests += [['pdump_autotest', true]]
+    test_deps += 'net_ring'
+    test_sources += 'test_pmd_ring_perf.c'
+    test_sources += 'test_pmd_ring.c'
+    test_sources += 'test_event_eth_tx_adapter.c'
+    test_sources += 'test_bitratestats.c'
+    test_sources += 'test_latencystats.c'
+    test_sources += 'sample_packet_forward.c'
+    test_sources += 'test_pdump.c'
+    fast_tests += [['ring_pmd_autotest', true]]
+    perf_test_names += 'ring_pmd_perf_autotest'
+    fast_tests += [['event_eth_tx_adapter_autotest', false]]
+    fast_tests += [['bitratestats_autotest', true]]
+    fast_tests += [['latencystats_autotest', true]]
+    fast_tests += [['pdump_autotest', true]]
 endif
 
 if dpdk_conf.has('RTE_LIB_POWER')
-	test_deps += 'power'
+    test_deps += 'power'
 endif
 if dpdk_conf.has('RTE_LIB_KNI')
-	test_deps += 'kni'
+    test_deps += 'kni'
 endif
 if dpdk_conf.has('RTE_LIB_PDUMP')
-	test_deps += 'pdump'
+    test_deps += 'pdump'
 endif
 
 if cc.has_argument('-Wno-format-truncation')
@@ -408,38 +410,38 @@ cflags += ['-DALLOW_INTERNAL_API']
 
 test_dep_objs = []
 if dpdk_conf.has('RTE_LIB_COMPRESSDEV')
-	compress_test_dep = dependency('zlib', required: false, method: 'pkg-config')
-	if compress_test_dep.found()
-		test_dep_objs += compress_test_dep
-		test_sources += 'test_compressdev.c'
-		test_deps += 'compressdev'
-		fast_tests += [['compressdev_autotest', false]]
-	endif
+    compress_test_dep = dependency('zlib', required: false, method: 'pkg-config')
+    if compress_test_dep.found()
+        test_dep_objs += compress_test_dep
+        test_sources += 'test_compressdev.c'
+        test_deps += 'compressdev'
+        fast_tests += [['compressdev_autotest', false]]
+    endif
 endif
 
 if dpdk_conf.has('RTE_CRYPTO_SCHEDULER')
-	driver_test_names += 'cryptodev_scheduler_autotest'
-	test_deps += 'crypto_scheduler'
+    driver_test_names += 'cryptodev_scheduler_autotest'
+    test_deps += 'crypto_scheduler'
 endif
 
 foreach d:test_deps
-	def_lib = get_option('default_library')
-	test_dep_objs += get_variable(def_lib + '_rte_' + d)
+    def_lib = get_option('default_library')
+    test_dep_objs += get_variable(def_lib + '_rte_' + d)
 endforeach
 
 link_libs = []
 if get_option('default_library') == 'static'
-	link_libs = dpdk_static_libraries + dpdk_drivers
+    link_libs = dpdk_static_libraries + dpdk_drivers
 endif
 
 dpdk_test = executable('dpdk-test',
-	test_sources,
-	link_whole: link_libs,
-	dependencies: test_dep_objs,
-	c_args: cflags,
-	install_rpath: join_paths(get_option('prefix'),
-			 driver_install_path),
-	install: true)
+        test_sources,
+        link_whole: link_libs,
+        dependencies: test_dep_objs,
+        c_args: cflags,
+        install_rpath: join_paths(get_option('prefix'),
+             driver_install_path),
+        install: true)
 
 has_hugepage = run_command('has-hugepage.sh').stdout().strip() != '0'
 message('hugepage availability: @0@'.format(has_hugepage))
@@ -455,59 +457,59 @@ num_cores_arg = '-l ' + run_command(get_coremask).stdout().strip()
 default_test_args = [num_cores_arg]
 
 foreach arg : fast_tests
-	test_args = default_test_args
-	run_test = true
-	if not has_hugepage
-		if arg[1]
-			test_args += ['--no-huge', '-m', '2048']
-		else
-			run_test = false
-		endif
-	endif
+    test_args = default_test_args
+    run_test = true
+    if not has_hugepage
+        if arg[1]
+            test_args += ['--no-huge', '-m', '2048']
+        else
+            run_test = false
+        endif
+    endif
 
-	if (get_option('default_library') == 'shared' and
-		arg[0] == 'event_eth_tx_adapter_autotest')
-		foreach drv:dpdk_drivers
-			test_args += ['-d', drv.full_path().split('.a')[0] + '.so']
-		endforeach
-	endif
-	if is_linux
-		test_args += ['--file-prefix=@0@'.format(arg[0])]
-	endif
+    if (get_option('default_library') == 'shared' and
+        arg[0] == 'event_eth_tx_adapter_autotest')
+        foreach drv:dpdk_drivers
+            test_args += ['-d', drv.full_path().split('.a')[0] + '.so']
+        endforeach
+    endif
+    if is_linux
+        test_args += ['--file-prefix=@0@'.format(arg[0])]
+    endif
 
-	if run_test
-		test(arg[0], dpdk_test,
-			env : ['DPDK_TEST=' + arg[0]],
-			args : test_args,
-			timeout : timeout_seconds_fast,
-			is_parallel : false,
-			suite : 'fast-tests')
-	endif
+    if run_test
+        test(arg[0], dpdk_test,
+                env : ['DPDK_TEST=' + arg[0]],
+                args : test_args,
+                timeout : timeout_seconds_fast,
+                is_parallel : false,
+                suite : 'fast-tests')
+    endif
 endforeach
 
 foreach arg : perf_test_names
-	test(arg, dpdk_test,
-	env : ['DPDK_TEST=' + arg],
-	args : default_test_args,
-	timeout : timeout_seconds,
-	is_parallel : false,
-	suite : 'perf-tests')
+    test(arg, dpdk_test,
+            env : ['DPDK_TEST=' + arg],
+            args : default_test_args,
+            timeout : timeout_seconds,
+            is_parallel : false,
+            suite : 'perf-tests')
 endforeach
 
 foreach arg : driver_test_names
-	test(arg, dpdk_test,
-		env : ['DPDK_TEST=' + arg],
-		args : default_test_args,
-		timeout : timeout_seconds,
-		is_parallel : false,
-		suite : 'driver-tests')
+    test(arg, dpdk_test,
+            env : ['DPDK_TEST=' + arg],
+            args : default_test_args,
+            timeout : timeout_seconds,
+            is_parallel : false,
+            suite : 'driver-tests')
 endforeach
 
 foreach arg : dump_test_names
-	test(arg, dpdk_test,
-		env : ['DPDK_TEST=' + arg],
-		args : default_test_args,
-		timeout : timeout_seconds,
-		is_parallel : false,
-		suite : 'debug-tests')
+    test(arg, dpdk_test,
+            env : ['DPDK_TEST=' + arg],
+            args : default_test_args,
+            timeout : timeout_seconds,
+            is_parallel : false,
+            suite : 'debug-tests')
 endforeach