diff --git a/app/test-eventdev/meson.build b/app/test-eventdev/meson.build
index 04117dbe4..45c3ff456 100644
--- a/app/test-eventdev/meson.build
+++ b/app/test-eventdev/meson.build
@@ -14,6 +14,6 @@ sources = files(
         'test_perf_queue.c',
         'test_pipeline_atq.c',
         'test_pipeline_common.c',
-        'test_pipeline_queue.c'
+        'test_pipeline_queue.c',
 )
 deps += 'eventdev'
diff --git a/config/x86/meson.build b/config/x86/meson.build
index 34b116481..b9348c44d 100644
--- a/config/x86/meson.build
+++ b/config/x86/meson.build
@@ -22,18 +22,18 @@ foreach f:base_flags
 endforeach
 
 optional_flags = [
-    'AES',
-    'AVX',
-    'AVX2',
-    'AVX512BW',
-    'AVX512CD',
-    'AVX512DQ',
-    'AVX512F',
-    'AVX512VL',
-    'PCLMUL',
-    'RDRND',
-    'RDSEED',
-    'VPCLMULQDQ',
+        'AES',
+        'AVX',
+        'AVX2',
+        'AVX512BW',
+        'AVX512CD',
+        'AVX512DQ',
+        'AVX512F',
+        'AVX512VL',
+        'PCLMUL',
+        'RDRND',
+        'RDSEED',
+        'VPCLMULQDQ',
 ]
 foreach f:optional_flags
     if cc.get_define('__@0@__'.format(f), args: machine_args) == '1'
diff --git a/drivers/bus/fslmc/meson.build b/drivers/bus/fslmc/meson.build
index e99218ca7..54be76f51 100644
--- a/drivers/bus/fslmc/meson.build
+++ b/drivers/bus/fslmc/meson.build
@@ -21,7 +21,7 @@ sources = files(
         'portal/dpaa2_hw_dpci.c',
         'portal/dpaa2_hw_dpio.c',
         'qbman/qbman_portal.c',
-        'qbman/qbman_debug.c'
+        'qbman/qbman_debug.c',
 )
 
 includes += include_directories('mc', 'qbman/include', 'portal')
diff --git a/drivers/common/mlx5/meson.build b/drivers/common/mlx5/meson.build
index b5585d2cc..e78b4f47b 100644
--- a/drivers/common/mlx5/meson.build
+++ b/drivers/common/mlx5/meson.build
@@ -23,7 +23,7 @@ cflags_options = [
         '-Wno-strict-prototypes',
         '-D_BSD_SOURCE',
         '-D_DEFAULT_SOURCE',
-        '-D_XOPEN_SOURCE=600'
+        '-D_XOPEN_SOURCE=600',
 ]
 foreach option:cflags_options
     if cc.has_argument(option)
diff --git a/drivers/common/sfc_efx/base/meson.build b/drivers/common/sfc_efx/base/meson.build
index 313e53d77..9fba47b1c 100644
--- a/drivers/common/sfc_efx/base/meson.build
+++ b/drivers/common/sfc_efx/base/meson.build
@@ -70,7 +70,7 @@ extra_flags = [
         '-Wno-unused-parameter',
         '-Wno-unused-variable',
         '-Wno-empty-body',
-        '-Wno-unused-but-set-variable'
+        '-Wno-unused-but-set-variable',
 ]
 
 c_args = cflags
diff --git a/drivers/common/sfc_efx/meson.build b/drivers/common/sfc_efx/meson.build
index d87ba396b..f42ccf609 100644
--- a/drivers/common/sfc_efx/meson.build
+++ b/drivers/common/sfc_efx/meson.build
@@ -19,13 +19,13 @@ extra_flags = []
 
 # Enable more warnings
 extra_flags += [
-        '-Wdisabled-optimization'
+        '-Wdisabled-optimization',
 ]
 
 # Compiler and version dependent flags
 extra_flags += [
         '-Waggregate-return',
-        '-Wbad-function-cast'
+        '-Wbad-function-cast',
 ]
 
 foreach flag: extra_flags
diff --git a/drivers/compress/mlx5/meson.build b/drivers/compress/mlx5/meson.build
index c5c5edfa7..7aac32998 100644
--- a/drivers/compress/mlx5/meson.build
+++ b/drivers/compress/mlx5/meson.build
@@ -17,7 +17,7 @@ cflags_options = [
         '-Wno-strict-prototypes',
         '-D_BSD_SOURCE',
         '-D_DEFAULT_SOURCE',
-        '-D_XOPEN_SOURCE=600'
+        '-D_XOPEN_SOURCE=600',
 ]
 foreach option:cflags_options
     if cc.has_argument(option)
diff --git a/drivers/crypto/bcmfs/meson.build b/drivers/crypto/bcmfs/meson.build
index 0388ba19a..d67e78d51 100644
--- a/drivers/crypto/bcmfs/meson.build
+++ b/drivers/crypto/bcmfs/meson.build
@@ -16,5 +16,5 @@ sources = files(
         'bcmfs_sym_capabilities.c',
         'bcmfs_sym_session.c',
         'bcmfs_sym.c',
-        'bcmfs_sym_engine.c'
+        'bcmfs_sym_engine.c',
 )
diff --git a/drivers/crypto/nitrox/meson.build b/drivers/crypto/nitrox/meson.build
index 2fdae03c1..2cc47c462 100644
--- a/drivers/crypto/nitrox/meson.build
+++ b/drivers/crypto/nitrox/meson.build
@@ -14,5 +14,5 @@ sources = files(
         'nitrox_sym.c',
         'nitrox_sym_capabilities.c',
         'nitrox_sym_reqmgr.c',
-        'nitrox_qp.c'
+        'nitrox_qp.c',
 )
diff --git a/drivers/crypto/qat/meson.build b/drivers/crypto/qat/meson.build
index 4da819d65..b3b2d1725 100644
--- a/drivers/crypto/qat/meson.build
+++ b/drivers/crypto/qat/meson.build
@@ -17,7 +17,7 @@ if dep.found()
             'qat_asym_pmd.c',
             'qat_sym.c',
             'qat_sym_hw_dp.c',
-			'qat_sym_pmd.c',
+            'qat_sym_pmd.c',
             'qat_sym_session.c',
 	)
     qat_ext_deps += dep
diff --git a/drivers/net/e1000/base/meson.build b/drivers/net/e1000/base/meson.build
index 99468764e..317692dfa 100644
--- a/drivers/net/e1000/base/meson.build
+++ b/drivers/net/e1000/base/meson.build
@@ -19,7 +19,7 @@ sources = [
         'e1000_nvm.c',
         'e1000_osdep.c',
         'e1000_phy.c',
-        'e1000_vf.c'
+        'e1000_vf.c',
 ]
 
 error_cflags = ['-Wno-uninitialized', '-Wno-unused-parameter',
diff --git a/drivers/net/fm10k/base/meson.build b/drivers/net/fm10k/base/meson.build
index 6467a1278..ca98d34d4 100644
--- a/drivers/net/fm10k/base/meson.build
+++ b/drivers/net/fm10k/base/meson.build
@@ -7,7 +7,7 @@ sources = [
         'fm10k_mbx.c',
         'fm10k_pf.c',
         'fm10k_tlv.c',
-        'fm10k_vf.c'
+        'fm10k_vf.c',
 ]
 
 error_cflags = ['-Wno-unused-parameter', '-Wno-unused-value',
diff --git a/drivers/net/i40e/base/meson.build b/drivers/net/i40e/base/meson.build
index c319902cd..79a887a29 100644
--- a/drivers/net/i40e/base/meson.build
+++ b/drivers/net/i40e/base/meson.build
@@ -8,7 +8,7 @@ sources = [
         'i40e_diag.c',
         'i40e_hmc.c',
         'i40e_lan_hmc.c',
-        'i40e_nvm.c'
+        'i40e_nvm.c',
 ]
 
 error_cflags = ['-Wno-sign-compare', '-Wno-unused-value',
diff --git a/drivers/net/ixgbe/base/meson.build b/drivers/net/ixgbe/base/meson.build
index 4d5e41bde..7d3cec002 100644
--- a/drivers/net/ixgbe/base/meson.build
+++ b/drivers/net/ixgbe/base/meson.build
@@ -14,7 +14,7 @@ sources = [
         'ixgbe_phy.c',
         'ixgbe_vf.c',
         'ixgbe_x540.c',
-        'ixgbe_x550.c'
+        'ixgbe_x550.c',
 ]
 
 error_cflags = ['-Wno-unused-value',
diff --git a/drivers/net/octeontx/base/meson.build b/drivers/net/octeontx/base/meson.build
index 0a69dfd46..c86a72670 100644
--- a/drivers/net/octeontx/base/meson.build
+++ b/drivers/net/octeontx/base/meson.build
@@ -4,7 +4,7 @@
 sources = [
         'octeontx_pkovf.c',
         'octeontx_pkivf.c',
-        'octeontx_bgx.c'
+        'octeontx_bgx.c',
 ]
 
 depends = ['ethdev', 'mempool_octeontx']
diff --git a/drivers/net/sfc/meson.build b/drivers/net/sfc/meson.build
index b58425bf9..ccf5984d8 100644
--- a/drivers/net/sfc/meson.build
+++ b/drivers/net/sfc/meson.build
@@ -24,13 +24,13 @@ extra_flags += '-Wno-strict-aliasing'
 
 # Enable more warnings
 extra_flags += [
-        '-Wdisabled-optimization'
+        '-Wdisabled-optimization',
 ]
 
 # Compiler and version dependent flags
 extra_flags += [
         '-Waggregate-return',
-        '-Wbad-function-cast'
+        '-Wbad-function-cast',
 ]
 
 foreach flag: extra_flags
diff --git a/drivers/net/thunderx/base/meson.build b/drivers/net/thunderx/base/meson.build
index 9cf4bf553..704ee6577 100644
--- a/drivers/net/thunderx/base/meson.build
+++ b/drivers/net/thunderx/base/meson.build
@@ -4,7 +4,7 @@
 sources = [
         'nicvf_hw.c',
         'nicvf_mbox.c',
-        'nicvf_bsvf.c'
+        'nicvf_bsvf.c',
 ]
 
 c_args = cflags
diff --git a/drivers/raw/skeleton/meson.build b/drivers/raw/skeleton/meson.build
index b5d87652f..950a33cc2 100644
--- a/drivers/raw/skeleton/meson.build
+++ b/drivers/raw/skeleton/meson.build
@@ -3,6 +3,6 @@
 
 deps += ['rawdev', 'kvargs', 'mbuf', 'bus_vdev']
 sources = files(
-		'skeleton_rawdev.c',
+        'skeleton_rawdev.c',
         'skeleton_rawdev_test.c',
 )
diff --git a/examples/l3fwd/meson.build b/examples/l3fwd/meson.build
index 773ebf478..0830b3eb3 100644
--- a/examples/l3fwd/meson.build
+++ b/examples/l3fwd/meson.build
@@ -9,11 +9,11 @@
 allow_experimental_apis = true
 deps += ['hash', 'lpm', 'fib', 'eventdev']
 sources = files(
-    'l3fwd_em.c',
-    'l3fwd_event.c',
-    'l3fwd_event_internal_port.c',
-    'l3fwd_event_generic.c',
-    'l3fwd_fib.c',
-    'l3fwd_lpm.c',
-    'main.c',
+        'l3fwd_em.c',
+        'l3fwd_event.c',
+        'l3fwd_event_internal_port.c',
+        'l3fwd_event_generic.c',
+        'l3fwd_fib.c',
+        'l3fwd_lpm.c',
+        'main.c',
 )
diff --git a/examples/multi_process/client_server_mp/mp_client/meson.build b/examples/multi_process/client_server_mp/mp_client/meson.build
index 3c4848bde..c7190b212 100644
--- a/examples/multi_process/client_server_mp/mp_client/meson.build
+++ b/examples/multi_process/client_server_mp/mp_client/meson.build
@@ -10,5 +10,5 @@ includes += include_directories('../shared')
 
 allow_experimental_apis = true
 sources = files(
-        'client.c'
+        'client.c',
 )
diff --git a/examples/multi_process/client_server_mp/mp_server/meson.build b/examples/multi_process/client_server_mp/mp_server/meson.build
index 74814e5fe..9e585e80b 100644
--- a/examples/multi_process/client_server_mp/mp_server/meson.build
+++ b/examples/multi_process/client_server_mp/mp_server/meson.build
@@ -10,5 +10,7 @@ includes += include_directories('../shared')
 
 allow_experimental_apis = true
 sources = files(
-        'args.c', 'init.c', 'main.c'
+        'args.c',
+        'init.c',
+        'main.c',
 )
diff --git a/examples/multi_process/hotplug_mp/meson.build b/examples/multi_process/hotplug_mp/meson.build
index ae9290504..a1ad98ca2 100644
--- a/examples/multi_process/hotplug_mp/meson.build
+++ b/examples/multi_process/hotplug_mp/meson.build
@@ -8,5 +8,6 @@
 
 allow_experimental_apis = true
 sources = files(
-        'commands.c', 'main.c'
+        'commands.c',
+        'main.c',
 )
diff --git a/examples/multi_process/simple_mp/meson.build b/examples/multi_process/simple_mp/meson.build
index adb06b0a7..359af4384 100644
--- a/examples/multi_process/simple_mp/meson.build
+++ b/examples/multi_process/simple_mp/meson.build
@@ -8,5 +8,6 @@
 
 allow_experimental_apis = true
 sources = files(
-        'mp_commands.c', 'main.c'
+        'mp_commands.c',
+        'main.c',
 )
diff --git a/examples/multi_process/symmetric_mp/meson.build b/examples/multi_process/symmetric_mp/meson.build
index a5b988c44..e768a324d 100644
--- a/examples/multi_process/symmetric_mp/meson.build
+++ b/examples/multi_process/symmetric_mp/meson.build
@@ -8,5 +8,5 @@
 
 allow_experimental_apis = true
 sources = files(
-        'main.c'
+        'main.c',
 )
diff --git a/lib/mbuf/meson.build b/lib/mbuf/meson.build
index c8c08220a..0435c5e62 100644
--- a/lib/mbuf/meson.build
+++ b/lib/mbuf/meson.build
@@ -12,6 +12,6 @@ headers = files(
         'rte_mbuf_core.h',
         'rte_mbuf_ptype.h',
         'rte_mbuf_pool_ops.h',
-        'rte_mbuf_dyn.h'
+        'rte_mbuf_dyn.h',
 )
 deps += ['mempool']
diff --git a/lib/meson.build b/lib/meson.build
index c9a20f65b..64a59abab 100644
--- a/lib/meson.build
+++ b/lib/meson.build
@@ -82,9 +82,9 @@ if is_windows
 endif
 
 optional_libs = [
-    'kni',
-    'power',
-    'vhost',
+        'kni',
+        'power',
+        'vhost',
 ]
 
 disabled_libs = []
diff --git a/lib/power/meson.build b/lib/power/meson.build
index a2cc9fe2e..c1097d32f 100644
--- a/lib/power/meson.build
+++ b/lib/power/meson.build
@@ -19,6 +19,6 @@ headers = files(
         'rte_power.h',
         'rte_power_empty_poll.h',
         'rte_power_pmd_mgmt.h',
-        'rte_power_guest_channel.h'
+        'rte_power_guest_channel.h',
 )
 deps += ['timer', 'ethdev']
diff --git a/lib/table/meson.build b/lib/table/meson.build
index 230f21ea8..b7b70b805 100644
--- a/lib/table/meson.build
+++ b/lib/table/meson.build
@@ -36,5 +36,5 @@ deps += ['mbuf', 'port', 'lpm', 'hash', 'acl']
 indirect_headers += files(
         'rte_lru_arm64.h',
         'rte_lru_x86.h',
-        'rte_table_hash_func_arm64.h'
+        'rte_table_hash_func_arm64.h',
 )