diff --git a/app/test-acl/input/acl1v4_5_rule b/app/test-acl/input/acl1v4_5_rule
new file mode 100644
index 0000000000..45301f3a3d
--- /dev/null
+++ b/app/test-acl/input/acl1v4_5_rule
@@ -0,0 +1,5 @@
+@16.32.1.1/32	2.1.0.0/16	0 : 65535	0 : 65535 0/0
+@16.32.1.0/24	2.1.1.0/24	0 : 65535	0 : 65535 0/0
+@2.1.0.0/16	16.32.1.1/32	0 : 65535	0 : 65535 0/0
+@2.1.0.0/16	16.32.1.0/24	1000 : 2000	0 : 65535 0/0
+@2.1.1.0/24	16.32.1.0/24	0 : 65535	0 : 65535 0/0
diff --git a/app/test-acl/input/acl1v4_5_trace b/app/test-acl/input/acl1v4_5_trace
new file mode 100644
index 0000000000..bfbcd31f88
--- /dev/null
+++ b/app/test-acl/input/acl1v4_5_trace
@@ -0,0 +1,5 @@
+0x10200101 0x02010304 100 100 6 0
+0x10200103 0x02010104 100 100 6 1
+0x02010304 0x10200101 100 100 6 2
+0x02010104 0x10200103 100 100 6 4
+0x02010104 0x10200101 100 100 6 2
diff --git a/app/test-acl/input/acl1v6_1_rule b/app/test-acl/input/acl1v6_1_rule
new file mode 100644
index 0000000000..2ea9856b27
--- /dev/null
+++ b/app/test-acl/input/acl1v6_1_rule
@@ -0,0 +1 @@
+@9baa:cead:8000:0000:e300:00ff:fe04:c5a8/33	d1b5:2feb:0000:0000:6600:00ff:fed9:aeaa/33	0 : 65535	1526 : 1526	0x00/0x00
diff --git a/app/test-acl/input/acl1v6_1_trace b/app/test-acl/input/acl1v6_1_trace
new file mode 100644
index 0000000000..6e86741edf
--- /dev/null
+++ b/app/test-acl/input/acl1v6_1_trace
@@ -0,0 +1,2 @@
+9baa:cead:8000:0000:0000:0000:0000:0000 d1b5:2feb:0000:0000:0000:0000:0000:0000 37826 1526 6 0
+2eba:cc41:0000:0000:0000:0000:0000:0000 16ef:6cdb:0000:0000:0000:0000:0000:0000 25946 1525 0 4294967295
diff --git a/app/test-acl/test-acl.sh b/app/test-acl/test-acl.sh
new file mode 100644
index 0000000000..348962c540
--- /dev/null
+++ b/app/test-acl/test-acl.sh
@@ -0,0 +1,92 @@
+#! /bin/bash
+# SPDX-License-Identifier: BSD-3-Clause
+
+# Usage:
+# /bin/bash <test-acl-binary> <dir-with-acl-rules-traces> <acl-alg> <burst-size>
+# Expected file-naming conventions:
+#   - for rules: 'acl[0-9]v[4,6]_[0-9,a-z]+_rule'
+#   - for traces: 'acl[0-9]v[4,6]_[0-9,a-z]+_trace'
+# Each rule file expects to have exactly one trace file.
+# test-acl app follows classbench file format.
+# Each line defines exactly one rule/trace.
+# rules record format:
+# '@'<src_ip_addr>'/'<masklen><space> \
+# <dst_ipv4_addr>'/'<masklen><space> \
+# <src_port_low><space>":"<src_port_high><space> \
+# <dst_port_low><space>":"<dst_port_high><space> \
+# <proto>'/'<mask>
+# trace record format:
+# <src_ip_addr><space><dst_ip_addr><space> \
+# <src_port><space<dst_port><space><proto>...<rule_id>
+#
+# As an example:
+# /bin/bash app/test-acl/test-acl.sh build/app/dpdk-test-acl \
+# app/test-acl/input scalar 32
+#
+# Refer to test-acl app for more information about rules/trace files format,
+# available test-acl command-line options, etc.
+
+TACL_PATH=$1
+TACL_DIR=$2
+TACL_ALG=$3
+TACL_STEP=$4
+
+if [[ ! -x ${TACL_PATH} ]]; then
+	echo "invalid TACL_PATH=${TACL_PATH}"
+	exit 127
+fi
+
+if [[ ! -d ${TACL_DIR} ]]; then
+	echo "invalid TACL_DIR=${TACL_DIR}"
+	exit 127
+fi
+
+V4F=`find ${TACL_DIR} -type f | egrep -e 'acl[0-9]v4_[0-9,a-z]+_rule$'`
+V6F=`find ${TACL_DIR} -type f | egrep -e 'acl[0-9]v6_[0-9,a-z]+_rule$'`
+
+run_test()
+{
+	i=$1
+	n=`basename ${i}`
+
+	TRACEF=`echo ${i} | sed -e 's/_rule$/_trace/'`
+	if [[ ! -f ${TRACEF} ]]; then
+		echo "${TRACEF} not found"
+		echo "test ${n} FAILED"
+		exit 127
+	fi
+
+	OUTF=`mktemp ${n}_XXXXXX`
+	echo "start test ${n} with alg ${TACL_ALG}, burst-size ${TACL_STEP}"
+	${TACL_PATH} -l 0 -n 4 --log-level="acl,debug" \
+		--force-max-simd-bitwidth=0 --no-pci -- \
+		${XPRM} --tracenum=200000 --rulesf=${i} --tracef=${TRACEF} \
+		--tracestep=${TACL_STEP} --alg=${TACL_ALG} \
+		> ${OUTF}
+	grep 'result:' ${OUTF} | awk '{print $(NF);}' > ${OUTF}.out
+	sed -e '/^#/d' -e 's/[[:space:]]*$//g' ${TRACEF} | \
+		awk '{print $(NF);}' > ${OUTF}.chk
+	diff -u ${OUTF}.chk ${OUTF}.out
+	st=$?
+	if [[ $st -ne 0 ]]; then
+	echo "test ${n} FAILED"
+	echo "output files:"
+		ls ${OUTF}*
+		cat ${OUTF}*
+		exit 127
+	fi
+	rm -f ${OUTF}*
+	echo "test ${n} OK"
+}
+
+for i in ${V4F}; do
+	run_test $i
+done
+
+for i in ${V6F}; do
+	XPRM='--ipv6'
+	run_test $i
+	unset XPRM
+done
+
+echo "All tests have ended successfully"